package com.nisum.webfluxday2.service;

import com.nisum.webfluxday2.model.ProductRequest;
import com.nisum.webfluxday2.model.ProductResponse;
import com.nisum.webfluxday2.repository.ProductRepository;
import com.nisum.webfluxday2.repository.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class ProductService {

    @Autowired
    ProductRepository productRepository;

    public Flux<ProductResponse> getAll() {
        Flux<Product> allProducts = productRepository.findAll();
        System.out.println(allProducts);
        return allProducts.map(product -> new ProductResponse(product));
    }

    public Mono<ProductResponse> addProduct(ProductRequest productRequest) {
        Mono<Product> newProduct = productRepository.insert(new Product(productRequest));
        return newProduct.map(product -> new ProductResponse(product));
    }

    public Mono<ProductResponse> findProduct(String id) {
        Mono<Product> product = productRepository.findById(id);
        return product.map(prod -> new ProductResponse(prod));
    }

    public Mono<ProductResponse> alterProduct(String id, ProductRequest productRequest) {

        System.out.println("put service");

        Mono<Product> product = productRepository.findById(id);

        return product.flatMap(prod -> {
            prod.setDescription(productRequest.getDescription());
            prod.setPrice(productRequest.getPrice());
            prod.setName(productRequest.getName());
            System.out.println("in put map");
            return productRepository.save(prod);
        }).map(prod -> new ProductResponse(prod));

    }


    public Mono<Void> deleteProduct(String id) {
        return productRepository.findById(id)
                .map(product -> productRepository.delete(product))
                .then();


    }
}
